     I have taken the liberty to define ruling and exalting signs for
the asteroids (and the rest of the first twenty objects that don't
already have them.) This won't affect much other than whether a 'R',
'F', 'e', or 'd' is displayed in the -v charts, but it will slightly
affect the powers given to these objects in the -j influence chart
since they can be in their ruling sign, etc. The -O object list will
display the list of ruling and exalting signs (and the fall and
debilitating signs which are just opposite the above) for all these
objects in addition to the planets; however, I have listed them below:

     Chiron, the compassionate, experienced healer, is most similar
in function to Pisces, hence Chiron rules here. Chiron expresses well
in caring, feeling, Cancer, hence Chiron exalts here. Ceres, goddess
of agriculture and representing the mothering, reproductive instinct,
is similar in function to Taurus, hence Ceres rules here. Ceres
expresses well in the nurturing, caring, sign of Cancer, hence Ceres
exalts here. Pallas Athena, mentally acute and unemotional, is most
similar in function to Virgo, hence Pallas rules here. Pallas
expresses well in practical, disciplined, introverted Capricorn,
hence Pallas exalts here. Juno, ability to sacrifice self-interests
to maintain a relationship, is most similar in function to
relationship oriented Libra, hence Juno rules here. Juno expresses
well in sociable, crowd pleasing Leo, hence Juno exalts here. Vesta,
with its orientation to directing hidden creative or sexual energy
without fear, is most similar in function to Scorpio, hence Vesta
rules here. Vesta expresses well in individualistic, quirky Aquarius,
hence Vesta exalts here.

     The North Node, with its emphasis on being able to break from
the past routine and pursue the unfamiliar and personal growth, is
most similar in function to society questioning independent Aquarius,
hence it rules here. The Node expresses well in growth and sacrifice
oriented Virgo, hence the Node exalts here. The Part of Fortune is
calculated based on the positions of the Sun, Moon, and Ascendant; if
these three objects are in their ruling signs, then the Fortune will
fall in Pisces, hence the Fortune should rule here. Similarly, if the
Sun, Moon, and Ascendant are all in their exalting signs, then the
Fortune will fall in Aquarius, hence the Fortune should exalt here.
The Midheaven, being the 10th house cusp, corresponds to Capricorn,
ruled by Saturn. Hence the Midheaven's ruling and exalting signs are
the same as Saturn's: Capricorn and Libra. The Ascendant corresponds
similarly to Mars, hence its ruling and exalting signs are the same:
Aries and Capricorn. The Vertex, being always near the Descendant,
corresponds to Libra, and hence has the same rulership and exaltation
as Venus: Libra and Pisces. The four minor house cusp objects are set
to have rulership of the sign corresponding to the house, and an
exaltation the same as the main planet which rules this sign, e.g.
the 2nd Cusp, corresponding to Taurus, ruled by Venus, rules Taurus
and exalts in Libra.

     Each uranian also has been assigned its own ruling and exalting
sign, meaning uranians in their rulership, etc, will be flagged as
such and have more or less influence and so on. I also came up with
these myself and used the interpretation strings to decide what the
most appropriate signs are. If you disagree, feel free to change
them, or I'll be willing to describe in more detail why I chose what
I did for them. Specifically, Cupido rules Libra and exalts in
Gemini, Hades rules Scorpio and exalts in Virgo, Zeus rules Leo and
exalts in Aries, Kronos rules Capricorn and exalts in Sagittarius,
Apollon rules Sagittarius and exalts in Aquarius, Admetos rules Virgo
and exalts in Scorpio, Vulkanus rules Aries and exalts in Leo, and
finally Poseidon rules Sagittarius and exalts in Pisces.

     The standard chart listing of the planetary positions will also
include an additional field for the "velocity" of each planet. This
velocity value approximates how fast the planet is moving through the
zodiac with respect to the Earth (or whatever the central body is set
to) in degrees per day. This value of course, goes negative when a
planet goes retrograde. This is useful not only to get a feel for how
fast each planet moves through the zodiac, but to determine when a
planet is about to go retrograde or direct - the value approaches
zero when the planet changes direction.


**************************************
DATA DEFAULTS AND COMPILE TIME OPTIONS
**************************************

     Astrolog includes the ability to search an input file for
various default parameters to use in the program. This allows one to
easily change major defaults without having to recompile the program,
which is useful if, say, one receives a compiled executable from a
friend who had a different configuration. The program looks for the
file "astrolog.dat" in the current directory, and if not there, looks
for it in the default directory. Parameters in this file will
override any defaults compiled into the program, although the highest
priority is still given to the command line options. Note one doesn't
*have* to have this file in order to run the program - if not found
Astrolog will still run as before using the compile time defaults.

     Presently, the parameters one can change in this file are:
default time zone (as indicated with -z option), default longitude
and latitude (as in -l option), default zodiac system and zodiac
starting offset (as changed with -s option), number of aspects (-A
option), and default house system to use (values as in -c option).
Next is whether the -k Ansi graphics should always be in effect. If
the value here is non-zero, then it is assumed -k is always in
affect, and one needs then to use the -k switch to return to normal.
This is recommended for PC users who display charts on the screen
more often than they print one out. After this is the default number
of rows per house to pass to the -w wheel chart option. Next, the
value of the minor compile time variable DIVISIONS may be changed in
the file. This value tells how many "segments" we should divide each
day, etc, when doing aspect or transit searches (-d or -t). More
segments is slower but can be more accurate by a minute or two. I
suggest a value of 24 here for Unix systems and 8 for PC's, but it is
easy to experiment to see what would is best for you. One may
increase this value up to 2880 without problem (if they don't mind
the wait) which will mean a chart every 30 seconds for -d aspect in
day charts and one every 15 minutes for -t transit search charts.

     Next comes the default number of rows to include in each house
for the -w text wheel chart, which is four by default. Then there's a
field in the astrolog.dat file specifying the character width of the
screen, which is usually set to 80. This value is used to determine
what column to break lines at when formatting and printing the
interpretation paragraphs. So one may change this to accommodate
narrower or wider screens or printers. (Note that this will not
affect and has no relation to the 80 column clip flag below.)

     "European date format" feature: There's a flag in astrolog.dat
which determines whether dates are displayed in Month/Day/Year order
or in the more "European" Day/Month/Year format. Setting or clearing
this flag will specify the DMY or MDY format everywhere in the
program from text wheel charts to transit charts to the chart info
displayed in graphics charts. "European time format" feature: This is
another flag in astrolog.dat which is just like the above except that
it affects how times are displayed throughout the program. When
clear, times will be printed in a.m./p.m. format, while when set they
will be in the more "European" 24 hour clock.

     "Smart cusps" feature: This is a yet another setting, a simple
yes/no option that will affect the way -t transit search lists, -T
transit influence charts, and -m0 aspect lists are displayed. It can
only be set in this astrolog.dat file. If the value there is
non-zero, then transits to minor house cusps will be processed in a
more intuitive manner. First of all, aspects other than conjunctions
or oppositions to minor cusps will be ignored, e.g. a trine to the
11th house is redundant and isn't really useful; we are more
interested in the conjunction to the 3rd house cusp. Minor aspects to
the Ascendant and Midheaven, and all other objects, are left alone.
In addition, with smart cusps active, oppositions to minor house
cusps will be printed as conjunctions to the opposing cusp, e.g.
instead of "Jupiter Opp 3rd Cusp", we have the more logical "Jupiter
Con 9th Cusp". This is just another way to make transit charts
clearer and less confusing.

     "80 column clip" feature: This is another yes/no option that can
only be set in astrolog.dat. If set to non-zero, then we guarantee
that no text chart when displayed will overflow 80 columns. By
default, with all objects unrestricted, certain charts will have rows
more than 80 columns long, breaking up the chart making it very
difficult to read. The -r0 -g relationship aspect grid, and the -E
ephemeris listing, will normally go beyond the 80th column. With this
feature however, these and other charts that can go beyond column 80,
such as -L when uranians are unrestricted, will always be displayed
on one line, with columns that would go beyond the 80th not getting
printed.

     Then in the astrolog.dat file come default restriction values
(as with the -R option) for the first 20 objects (0 = active, 1 =
restricted). Some people just don't like or care about the various
minor bodies such as the asteroids, Chiron, Part of Fortune, etc.,
and think that they clutter up the various charts. This is a good way
to keep them from showing up by default (one can still use the -R
option to get back any objects eliminated here.) This is immediately
followed by a similar restriction list for planets when transiting in
the -T charts. Then come two flags which can be set to automatically
restrict sign changes and direction changes from appearing in the -d
chart displays. This works like the -R restrictions but for all types
of these special events, instead of all aspects or events containing
a particular object.

     Next come the default orbs (as with the -Ao option) for the 18
aspects. Then comes a list of the maximum orbs of any aspect allowed
to the first 20 objects (as with the -Am option), and after this is a
list of the amount to widen aspect orbs to the first 20 objects (as
with the -Ad option.) Then, for the -j influence interpretation
chart, four values indicating the power given to planets in ruling
sign, planets exalted in sign, planets in ruling house, and planets
exalted in house, may be specified. Finally neat the end of the file,
comes a long list of the main influence values used by the -j option,
i.e. the power values of each of the first 20 planet objects, of the
12 houses, and of the 18 aspects.

     At the very end of the astrolog.dat file are several options for
the graphics defaults. (Note that based on what options are compiled
into the program, anywhere from zero to all of the fields may be
relevant and hence even be read in.) The mode in which graphics
bitmap files are written to disk, like as specified with -Xb, is set
here, and like everything else in astrolog.dat can be used to
override the compile time value. The default horizontal and vertical
pixel size that a chart comes up on the PC screen or in an X window,
like as specified with -Xw, may be set here too. Finally, the default
DOS graphics modes may be customized, which are described later.

     "PostScript orientation" feature: One may choose the paper
orientation of full PostScript graphics charts as generated with the
-Xp0 switch. If this PS paper orientation value is positive, then
the chart will be printed in portrait mode, while if the value is
negative, then it will be printed in landscape mode. If the
orientation value is set to zero (the default), then the program will
decide based on the size of the current chart, with charts with
larger horizontal sizes (e.g. astro-graph charts and wheel charts
with sidebars) being in landscape, and charts with horizontal sizes
less than or equal to the vertical (e.g. aspect grids and wheel
charts without sidebars) being in portrait.

     "PostScript page size" feature: One may also choose the paper
size of full -Xp0 PostScript graphics charts. There are two settings
which specify the horizontal and vertical size in inches of the paper
to be printed upon. By default this is 8.5" x 11". If you have say
8.5" x 14" legal size or A4 paper in your printer it can be used just
as easily. (Note: It's been mentioned that at least some systems or
drivers may clip all graphics beyond 8.5" x 11", but excluding any
external restrictions Astrolog's PostScript should allow one to go
beyond these limits.)

     "Aspect grid cells" feature: Aspect grids by default are always
20 by 20 cells (21 by 21 when for the -r0 relationship comparison
grids). The actual value is also in the graphics section of the
astrolog.dat file can be increased or decreased as desired.

     "Alternate glyphs" feature: Astrolog has the ability to choose
between different common glyphs for various astrological symbols. One
may optionally display charts with the "European" version of the
Capricorn glyph, instead of the more twisty "American" type glyph.
One may also display charts with the "astronomical" version of the
Uranus glyph with a dotted circle with an ascending arrow, instead of
the more astrological "Herschel" glyph with the crescent bounded
cross over a circle. Finally one may display with the "astronomical"
version of the Pluto glyph as the "PL" initials, instead of the more
"astrological" version with the circle over crescent over cross.
There is one glyph selection numerical field in the astrolog.dat
file, which, if the ones place is "1" means use the alternate
Capricorn glyph, if the tens place is "1" means to use the alternate
Uranus glyph, and if the hundreds place is "1" means to use the
alternate Pluto. The default value is "0", but many astrologers on
the other side of the Atlantic may prefer "111". 

     About the only major thing that one *can't* change in the file
is the default directory path in which the program looks in for input
files if not in the current directory, since Astrolog needs the
default directory in order to be able to locate the file in the first
place! The compile time location of where to look for this file can
be overridden by the Astrolog environment variables described below.
The standard "astrolog.dat" file included with the release of the
program has some "comment lines" describing what is contained in each
line. One can chance or delete comments as long as they make sure
that an equals sign ('=') immediately proceeds any value or list of
values, since the program uses this character to determine where
comments end.

     Astrolog.dat files for versions 4.00 and before won't work with
version 4.10, because there are additional definable parameters
expected in the file read in for this version. Attempting to read in
such an old file into version 4.10 will result in an error message
saying one should upgrade the old file or delete it. Either delete
the old file and modify the one included with this release, or else
manually merge in the new fields in the new file with your old one.

--

     Astrolog 4.10 has several environment variables which may be set
to indicate directories where to find the various files it may look
for. Without them, the only place the program will look for chart
files, the astrolog.dat initialization file, and ephemeris files is
in the current directory and default directories set at compile time.
The program will look where any or all of these environment variables
point, if they are defined. The three environment variables are named
"ASTROLOG", "ASTR4.10", and "ASTR". On a PC you can set an
environment variable from the DOS prompt with a command such as "set
ASTROLOG=C:\PROGRAMS\ASTRO410\CHARTS". This command can be put in
your AUTOEXEC.BAT file to remain persistent. On a Unix system you can
set an environment variable from the shell with a command such as
"setenv ASTROLOG /username/programs/astro410/charts". This line can
be put in your .cshrc file to remain persistent. Note that the
ASTR4.10 environment variable is version specific, i.e. future
versions will ignore this variable and look in one such as ASTR4.20.
This allows one to have a directory for version specific files such
as the astrolog.dat file, and have multiple versions of Astrolog on
the system at once without them conflicting with each other. I
personally point ASTROLOG to my chart files directory, ASTR4.10 to my
astrolog.dat directory, and ASTR to my ephemeris directory, although
any file may be found with any of the variables. Specifically, when
Astrolog searches for a file, it will look in the following
directories, in order: The current directory, the ASTR4.10
environment variable directory, the ASTROLOG environment directory,
the ASTR dir, and finally the compile time default directory.

--

     Some systems (for example, Mac's) don't directly accept
parameter switches on the command line (such as Astrolog is being
booted from a menu.) Therefore, such a limitation makes one unable to
access many program features in the normal way. If this is the case
with your system (or if you just don't like command line options),
then comment out the '#define SWITCHES' line at the beginning of the
astrolog.h file. If you do this, then the program will ignore any
switches and prompt you to enter them manually at the very beginning
of program execution. You just enter one line containing all the
parameters together, separated by one or more spaces, just like is
done when typing in the command line. Astrolog will automatically
parse the string and extract the parameters, just like the operating
system shell does.

     Related to this, the "-." switch, when encountered on a command
line, will immediately terminate the program, ignoring any modes or
other command switches. This is the formal way how to really exit the
program when in the -Q loop (and really only useful in this case).
Remember, earlier it was said to enter "." for the command line to
exit the -Q mode. Well, Astrolog internally interprets the "." as a
switch without a leading dash, i.e. "-.", which is a switch that will
force program termination.

--

     I often use Astrolog to look at and compare files containing
charts of various people. I have many chart files, so I keep them in
a separate directory. Since it is always a pain to have to cd into
this special directory all the time, there is a DEFAULT_DIR string to
be set at compile time. Whenever the program reads in a chart file
with the -i option, it will first look in the current directory for
it. If it's not found there, Astrolog will then look for a file of
the same name in the special default directory.

     A couple of other compile time option variables are in the
include file astrolog.h: For those people who don't like Placidus, a
default house system can be set by changing the value of
DEFAULT_SYSTEM to the value from 0..9 indicating what system to use
if the user doesn't explicitly specify one with -c or in
astrolog.dat. A couple of other compile time options are in
astrolog.h which can be used to leave out certain parts of the
program which you don't desire to have or just take up memory and
make the executable larger. The #define INTERPRET can be commented
out to remove all the -I interpretation routines and tables. The
#define BIORHYTHM can be commented out to remove the non-astrological
-rb biorhythm text and graphical charts.

     There is a special compile time variable dealing with graphics
(in addition to the "X11" and "MSG" ones) called "GRAPH". One
comments out the #define GRAPH line if they don't want graphics, and
not just if they don't have X windows. In other words, one can
generate most of Astrolog's graphics charts even if they don't have X
windows or a PC with graphics abilities. Now, when GRAPH is defined
but X11 and MSG aren't, the program will generate the charts, but
just never try to bring up a window; it will simply always assume
that you are writing a bitmap file. The bitmap file will contain a
(unfortunately always black and white for the X bitmap format) image
of what would normally be in the window, just as the -Xb switch does.
One can then use various graphics utilities to convert the image into
something they can display on their system if they can't do so using
any of the available bitmap modes. (Any system that can compile
Astrolog should be able to compile in all the non screen graphics
features as well.)

     A bitmap output mode other than the Windows .bmp bitmaps and
standard ones that can be read with the Unix X11 xsetroot command is
allowed in the graphics routines. If one changes the BITMAPMODE
compile time option in astrolog.h to the character 'A' when
compiling, or invokes the -Xb switch as -Xba, then all bitmaps output
will be in a straight Ascii form, with one character corresponding to
each pixel. This format is identical to the result produced by the
Unix command bmtoa, and it can be converted back into a bitmap with
the Unix command atobm. Although not as efficient spacewise, this is
a simpler format, and is recommended for those without X windows who
are still using Astrolog's graphics, if they want to write their own
conversion program.


********************************
DESCRIPTION OF X WINDOW FEATURES
********************************

     One of the most impressive features of the program are the X
windows features, which are generally accessed in the program via the
-X switch and derivatives of it on the command line. There are five
different types of chart displays: A standard graphic display of a
wheel chart in a window (with glyphs, aspects in the center, etc),
graphic displays of the Astro-graph charts (which look almost
identical to the Astro*Carto*Graphy maps from Jim Lewis) complete
with all the labeled lines drawn on a map of the world (like the -L
option), aspect/midpoint grids showing the aspects and orbs in effect
between every body in a chart (like -g option), a local sky chart
showing where each planet is located on a map of the local horizon
area (as in -Z), and a space chart showing an aerial view of the
solar system (as in -S). The X wheel and aspect grid charts can
displayed in a different form to accommodate relationship comparison
charts. There are also other commands that can be given to the
window once it is up and running, which can do other things, such as
continually update the window every few seconds to the current status
(i.e. an extended version of the -n option) as well as other forms of
animation. Note that the program is still text based, and one can
easily turn off all the X features by commenting out the #define X11
in astrolog.h if they don't have X windows.

     Probably the only thing more impressive than the X window
features are the X window features displayed on color monitors. (The
charts displayed in color are *much* more eye catching than the B/W
ones, IMHO.) Here is how the colors have been assigned for the
various charts: Four colors have been allocated for the four elements
- Fire = Red, Earth = Brown, Air = Green, Water = Blue. The various
sign glyphs (and the corresponding house labels) are in the color of
their element. Planets are in the color of the sign of their main
ruler. Chiron and the four asteroids are Gold, while the north node,
and other non-physical objects like the fortune and vertex are
Violet. Representations of the Ascendant/ Descendant/ Midheaven/
Nadir (in the astro-graph map lines and elsewhere) are in the element
color of the corresponding sign/house that the angular lines refer
to, i.e. Ascendant = Red, Midheaven = Brown, Descendant = Green,
Nadir = Blue. A few extra things have been added for color wheel
charts only: dark gray lines marking off each house (in addition to
the main lines on the horizon and meridian), and each degree instead
of every 5th degree being marked in dark gray on the outer circle
(every 5th degree being white). Aspects lines are colored too, as
follows: Conjunctions = Yellow, Sextiles = Light Blue, Squares = Red,
Trines = Green, Oppositions = Dark Blue. For the minor aspects we
have: Inconjuncts/Semisextiles = Brown, Semisquares/
Sesquiquadratures = Orange, (Bi/Semi)Quintiles = Violet,
(Bi/Tri)Septiles = Gold, (Bi/Quatro)Noviles = Pink.

     For color X terminals, the -XG globe display and -XW world map
display are done with the continents in different colors! This makes
them look much better than monochrome maps. Each of the seven
continents is in a different color of the rainbow, and the colors are
chosen to correspond to the appropriate chakra (etheric energy vortex
along the human spine) that goes with each land mass. They are:
Africa - red - Root chakra, Australia - orange - Navel chakra, South
America - yellow - Solar plexus chakra, North America - green - Heart
chakra, Europe - blue - Throat chakra, Asia - indigo - Third Eye
chakra, Antarctica - violet - Crown chakra. Major lakes are, of
course, colored navy blue.

--

-v -X: The X wheel charts have their graphic information organized as
follows: There's an outer circle showing the signs and sign glyphs,
inside of which is a smaller circle divided up into 5 degree
increments to make determining exact degrees easier. Inside of this
is a circle divided up into the 12 houses labeled with numbers. The
entire chart is divided by two dashed lines through the Ascendant/
Descendant (which is always horizontal of course) and the
Midheaven/Nadir. Inside the house circle are the planet glyphs in
their appropriate positions. Small pointer lines run from each glyph
to just before single dots. These dots indicate the precise locations
in the zodiac of each object. The pointer lines (which are dashed if
the object is retrograde and solid otherwise) are necessary so as not
to have to draw planet glyphs on top of one another when planets are
conjunct. Inside the ring of the single dots, are the aspect lines
connecting these positions. Since the default number of aspects to
use is just the 5 majors, one can determine which aspect is in place
just by looking at the aspect line. The accuracy of the aspect is
determined by the dashedness of the line: A solid line means the orb
is < 2 degrees; a dashed line means the orb is < 4 degrees; a really
dashed line mean the orb is < 6 degrees, etc.

-v0 -X: Astrolog's wheel charts will be labeled more extensively than
just having the chart header information displayed at the bottom of
the graphic like in other chart modes. The wheels will include full
information on time, place, house system, zodiac, central planet,
element table info, as well as the actual positions of planet and
house cusps as displayed in the wheel. All this information is in a
"sidebar" to the right of the wheel which includes a listing not
unlike the -v text chart. (Note that the size of this sidebar is
such that for the default 480x480 pixel chart size, including the
sidebar will make it 640x480, which perfectly fills a VGA PC screen.)
If you want a standard style wheel with just the chart information at
the bottom of the graphic, set the -v0 flag, as in "-v0 -X" instead
of "-v -X" or just "-X".

-w -X: A different way of formatting the graphical wheel charts
described above is available by combining the -w switch with -X.
Normally all of Astrolog's wheel charts are such that each zodiac
sign is the same size. Due to different house sizes in most systems
however, this makes the houses appear different sizes on the wheel,
so that the Midheaven won't be the exact top of the chart for
instance. Some users may instead prefer "house oriented" as opposed
to sign oriented wheel charts. Astrolog, with the -w -X combination,
will make each house be the same size on the screen, and will
compress or expand the signs instead (of course this means that such
things as exact squares may not be between objects exactly 90 degrees
apart on the circle any more). When graphics are displayed on the
screen, the '0' key will toggle between the two forms of wheel chart.

-L -X: The graphical astro-graph charts are organized as follows: A map of
the world is shown. The edges of the map are labeled with ruler lines
that are 5 degrees apart (with longer ruler lines for more important
longitudes and latitudes, like those that are multiples of 10, 30,
etc.) The equator is labeled with a dashed line. The polar regions of
the world aren't shown; the map shown ranges from 60 degrees S
latitude to 75 degrees N latitude. Note that each pixel on the screen
represents exactly one half a degree on the world. (For -Xs 100 the
ratio is one pixel to one degree, and for -Xs 400 the ratio is one
pixel to 1/4 degree.) On this map are drawn the lines indicating
where on the world the various planets are angular at the time in
question. (Note: you might want to -R restrict some objects because
otherwise the map tends to get pretty cluttered with lines.) As
expected, Midheaven and Nadir lines are vertical, and the Ascendant
and Descendant lines are curved. Little square boxes on the Midheaven
lines indicate the exact zenith latitude location. Each line is
labeled at the top or the bottom of the screen, showing what planet
is in question and (sometimes) what angle is in question. All
Ascendant and Midheaven lines are labeled at the bottom of the
screen, and all Descendant and Nadir lines are labeled at the top.
Each line goes a bit beyond to the top or bottom of the world map,
and then another pointer segment (which is again dashed of the object
in question is retrograde) goes and points to the planet glyph. There
is a capital "A" or "M" under each of the glyphs at the bottom of the
screen, explicitly indicating whether the line is an Ascendant or
Midheaven line. At the top of the screen, however, there are only the
glyphs, but one can still determine whether these lines are
Descendant or Nadir lines based on whether they are curved or not.
Note that not all the Descendant lines are labeled; this is because
some of the Ascendant/Descendant lines actually connect near the top
of the screen and don't actually cross it. This graphic astro-graph
chart will display a small purple dot at the precise point on the
world map for which the chart in question is being generated. This is
useful to help see how close the various planetary lines are to you,
if you live in the middle of the continent or someplace not easily
determinable on the compact map of the world.

-g -X: Aspect grid graphics with the appropriate aspect glyphs can be
displayed by combining the -g option with the -X option (astrolog -g
-X). Both the split aspect/midpoint grids labeled down the diagonal,
as well as the relationship aspect grids between two charts (astrolog
-r <file1> <file2> -g -X) are supported. The aspects glyphs, objects,
and the signs in the grids are in their colors as defined earlier.
Like the astro-graph windows, these charts can't be resized in the
normal way unless one uses the '>' and '<' keys. For anything less
than the larger scale sizes (achieved with the switch -Xs 300, or by
pressing '>' within a window) all that will be displayed in each
aspect grid cell is the glyphs of the aspect in effect, the planet
being aspected, or the sign of the midpoint. However, once the
largest scale size is reached, there is room in each cell to display
the aspect orb to the nearest minute off of exact (with a plus or
minus sign indicating whether the actual angle is slightly greater
than or less than exact, or an 'a' or 's' if applying vs. separating
orbs are to be shown instead); the degree and minute in addition to
the sign for midpoints; and the degree and sign location for each
planet that's in the grid, as with the -g text charts.

-m -X: Combining the -m switch with -X will have the same result as
-g with -X, since the aspect grid shows both aspects and midpoints
separated by the grid diagonal. However, doing a relationship
midpoint chart (-r0 -m -X) will result in the relationship aspect
grid coming up but showing the midpoints instead of aspects, as
desired. The -r0 -m -X switch combination implicitly does the results
of the -g0 switch, which for relationship charts puts midpoints
instead of aspects in the grid.

-Z -X: The -Z local horizon feature can be displayed in an X window
as well (e.g. astrolog -Z -X), in which all the planets will be
displayed in a window depicting the sky. The small dot above or below
each glyph indicates exactly where each planet is. (Some of the
glyphs may be overlapping, although the program tries to cut down on
this.) There is a horizontal line dividing the window representing
the local horizon; planets above this line are visible, while planets
below it are set. There are three vertical lines dividing the window
as well: The middle line represents the due south direction, the one
to the left is due east, the one to the right is due west, and the
edges of the window are due north. (These directions are labeled in
the borders of the chart.) Like the standard chart display, this
window or graphic may be resized to any proportion. At any time one
can press the 'Z' key when a graphic is up to enter this display type
in that window.

-Z0 -X: An additional graphics chart is available through the -Z0
switch: local horizon charts suitable for stargazing. As we know, the
normal -Z switch generates a listing of the planets with respect to
the local horizon, and the -Z combined with the -X switch generates a
graphic image of the planets and stars on the local horizon. This
chart assumes one is facing due south, and is divided left to right
by the horizon line, with straight up being toward the top of the
screen and straight down toward the bottom. This is a good chart,
especially for noticing the rising and setting of planets and other
objects, but the fact that the meridian is split up causes distortion
when trying to view objects high up in the sky. Therefore, if one
combines this -Z0 switch with the -X switch, a differently oriented
local horizon chart will be displayed. Here, the zenith point
straight up is in the center of the screen, and the horizon line is a
surrounding circle. Due north is along the line from the center to
the top of the screen, due south is on the line from the center to
the bottom, east is to the left, and west is to the right. In other
words, this is just like what one would see if they were lying on
their back looking straight up with their feet to the south, so this
should be better for stargazing. Outside the circle marks what's
below the horizon, and the extreme corners of the screen mark the
nadir - what's straight down. As with the normal -Z graphic chart,
this one has the various axes marked at five degree increments.

-S -X: The -S switch can be combined with -X to give a graphics chart
of the solar system. This will be displayed as an aerial view of the
entire solar system, with 0 degrees Aries to the left of the screen,
0 degrees Cancer to the bottom, etc. Note that this chart includes
all possible planets, including the Earth (whose glyph is a cross
inside a circle). Whatever object is chosen to be the central body is
at the center of the screen, with all the others around it. This is a
fun chart to animate - watch the planets go around the Sun, and *see*
how they turn retrograde with respect to the Earth. In addition to
the bodies themselves, twelve spokes are drawn from the center body
to the edge of the screen, which delineate the zodiac with respect to
it. Note that the scale of the solar system is large; attempting to
fit all the planets out to Pluto on the screen at once will cause all
the inner planets to be crammed together near the middle of the
screen. To deal with this, the scale size as indicated with the -Xs
switch and the '<' and '>' keys will affect how much of the solar
system is viewed at once (in addition to the glyph sizes). For a
scale size of 400, the viewing region will have a radius of 1 AU
(just enough to cover out to the Earth's orbit). For a scale size of
300, the viewport will have a radius of 6 AU (about out to the orbit
of Jupiter; useful for viewing the inner planets). For a scale size
of 200 (default), it will have a radius of 30 AU (enough to include
Neptune, and Pluto most of the time). Finally, a scale size of 100
will result in a radius of 90 AU, enough to easily include the entire
solar system, as well as the orbits of the hypothetical Uranian
bodies beyond Pluto. Note that this chart (and its text version as
well) will usually leave the Earth's Moon out. The -b extended
Placalc formulas are required to be in effect (as well as either the
Sun or Earth being the central body) in order for the Moon to be able
to appear. At a 400% scale zoom with the Moon included as well, one
can actually get a feel for the relative distance of the Sun from the
Earth and the Moon from the Earth, although the chart will have to be
over 1000 pixels wide for the Moon to even appear one pixel away from
the Earth at all! 

-E -X: A graphical planetary tracking chart is available by combining
the -E switch with -X. This "graphical ephemeris" will display the
sign degrees of the zodiac along the horizontal axis, and the days in
the given month along the vertical. The positions of the planets at
each day are then graphed. The result is a bunch of wavy lines that
make it easy to see all the planetary movements during the month.
Wherever lines cross there's a conjunction on the day indicated on
the axis at the same level as the crossing. Although this only looks
at the month in the given chart information, the actual day will be
highlighted on the vertical axis. Combining the -Ey yearly ephemeris
instead with -X will generate a graphical ephemeris showing the
movements for the entire year, with the months labeled along the
vertical axis.

-r0 -X: True relationship wheel charts can be displayed in a window,
i.e. where the planets of both charts are displayed in separate rings
of the same wheel. Use the -r0 option to display this comparison
type. For example, for the command "astrolog -r0 person1 person2 -X",
the following is displayed: The signs and houses as in person1's
chart are drawn in the outermost part of the wheel. Inside this is a
ring of person2's planets as displayed in person1's houses, and
inside of this are person1's own planets. Finally at the very middle
is an aspect grid, which shows those aspects that are occurring
between the objects in the two charts. Basically this is just the
standard wheel chart for person1, except that person2's planets are
in an outer ring of objects and the aspect grid shows the aspects of
the relationship. Putting such a chart in animation mode only affects
person2's planets, so this is a great way to analyze transits: Doing
"astrolog -t yourchartfile -X" will show all your current transits,
and allow you to easily animate the transiting planets through your
natal signs and houses.

-rb -X: Graphical biorhythm charts are available by combining the -rb
(or -yb) switch with -X. This will make a graph of one's biorhythm
for the two weeks before and after the specified time, with days on
the horizontal axis and the Physical, Emotional, and Intellectual
percentages on the vertical. When any graphics chart is up, one may
press the 'Y' key to revert to a biorhythm chart. (Note that as this
is a relationship comparison chart, if you go to it from a graphics
mode only showing one chart, it will show the biorhythm for them at
their birth, and you will want to then animate or adjust it to get a
useful display.)

--

     A couple of conveniences for the graphics features exist. Note
that the -Xo <bitmapfilename> option is only used in conjunction with
the -Xb write output to bitmap switch. Therefore, -Xo automatically
assumes -Xb is set. (Invoking -Xb itself without -Xo will have the
program prompt the user for the bitmap filename.) In other words,
astrolog -Xb -Xo 'file' is the same as just astrolog -Xo 'file'.
Astrolog includes its own appropriate X bitmap (a rainbow over an
opened Third Eye) if one iconifies the window, instead of reverting
to the braindead UnknownIcon :)

     For X windows, one can animate a graphics chart on the root
background by combining -XB with the -Xn switch. This will be just
like the animations done in windows except the root is being used
instead. Astrolog can be run in the background this way to
continually update your root to the current chart representing the
present moment. Limitations with this are that since there's no
window, no keypresses can be processed so the program must be
manually terminated, and that the continual updates will be as CPU
intensive as the window animations are.

     Hack: Doing a relationship comparison graphic chart with the -S
space or -Z horizon charts in animation mode will not cause the
screen to be cleared between each screen update. This is a hack which
allows one to get the effect of a timed exposure as the objects move
across the sky in a -Z horizon chart, and allows one to see the
orbits of planets as they move around the sun in the -S charts.
(Note that it's best to not be in a flicker free graphics mode on
PC's so the updates all stay on one page, and to turn off object
labels with -Xl or the 'l' key so the screen doesn't fill with
glyphs.)

     Hack: Another fun hack is that doing a graphic wheel chart with
-I interpretation on (the interpretation setting normally doesn't
affect graphics in any way) will decorate the corners around the
wheel! How its decorated depends on the screen width setting in
astrolog.dat or passed to -I. If this value is even, a spider web
design will be put in each corner. If this value is odd, a moire
pattern will be put in each corner. The decoration looks best when
the screen width is around 79 or 80. The higher the value, the more
dense the lines will be in the "spider webs", or the less of the
screen the moire will cover. (Don't make the moire value too low or
you will cover the entire screen, which looks cool but doesn't aid
reading the chart any! :)


***********************************
DESCRIPTION OF PC GRAPHICS FEATURES
***********************************

     Astrolog's PC graphics charts look and feel and are displayed
just like the X window graphics already described. When compiling,
one has a choice between four options: (1) choose no graphics
abilities at all, (2) compile so that graphic chart bitmaps can be
generated and output to a file, (3) compile allowing file graphics in
addition to direct screen graphics in X windows, and (4) compile with
file graphics and direct graphics on the screen of a PC. The addition
of PC graphics in no way inhibits or affects the X window graphics
already in place; it's merely a matter of which compile time options
are set. Unix users don't need to look at this section.

     Astrolog uses the Microsoft PC graphics library as defined in
the file graph.h included with their C7 "C" language compiler. This
file and the graphics.lib library is needed in order to be able to
compile with these graphics options set, just as the X window
libraries are needed to compile with those graphics included. If
unavailable, one can still access these PC graphics with the library
linked in, in the already compiled executable posted.

     PC Astrolog is a DOS program and should be run from a DOS
prompt, outside of any Windows system. To generate a graphics chart
instead of a text one, include the -X switch just as one would do to
bring up an X window. The expected graphic chart will be displayed on
the screen unless the -Xb write bitmap to file switch is in effect.
The colors chosen for the graphics are basically identical to those
chosen in X window charts, and both of these in turn are based on the
Ansi colors used in the Ansi text charts.

     Now, there are many various types of PC monitors and
resolutions. Astrolog will automatically try to determine and pick
the highest resolution mode available on your system, so this need
not be worried about.

     The PC Astrolog charts may be animated in all the various ways,
and the animation will usually be flicker free! Now, PC's do have
limited memory, therefore there might not be room for more than one
page of graphics at the highest resolution. Hence, animation at the
highest (default) mode, may flicker; however, graphics at a slightly
lower resolution may take enough less memory to allow enough to do
flicker free animation. A special PC only feature for this has been
added: Pressing the 'tab' key while the PC graphics are up will try
to pick a lower resolution, where flicker free animation can be done.
Specifically, we'll toggle to a 640x350 EGA mode. On my own system,
the highest resolution I get is a 640x480 16 color VGA mode, however
the charts can't be animated without flicker. When I hit 'tab', I
drop from 480 lines of graphics to 350, but now the animation will be
perfectly smooth. The results with whatever graphics system you have
may be different.

     The chart that comes up will use as many pixels as is defined by
the chart's size as specified with the -Xw and -Xs switches. The 'Q'
change chart size to square key works just as before. However, on PC
screens we will try to take in account the pixel size ratio. On EGA
screens where the pixels are long and narrow, meaning a true "square"
chart looks tall and thin, we compensate by increasing the horizontal
size of the chart. The 'B' key, which for X window graphics will
blast the current window contents to the root background, is a
meaningless feature for a PC. This key, for PC graphics systems, will
instead resize the chart to be the full size of the screen. Note
that some charts however (such as wheel charts without sidebars, -S
space charts, -Z0 sky charts, and -XG globes) are distorted unless
they are square. For these charts, the 'B' key will resize the chart
to be the largest square that will fit on the screen, i.e. will
automatically do what pressing 'B' followed by the 'Q' force to
square key would do. When the graphics mode is changed through
'tab', the chart size will also be modified to be the largest
"square" that will fit on the screen.

     If the size of the chart is less than the size of the screen, it
will be displayed centered in the middle of the screen. If however
the chart size is greater than the screen size, then the chart will
take up the whole screen, and part of it will be clipped. By default
we show the upper left corner of the chart if this is the case. Now,
one can define and change which part of the chart gets shown. On PC's
the meaning of pressing the number keys have been enhanced. Normally,
number keys set the animation speed; they still do, but now only when
animation is actually being done. If not in animation, the number
keys from 1..9 will define which "quadrant" or area of the chart gets
shown. It's best to think of and use the number pad for this feature
(make sure num lock is on!) Pressing the '7' key, i.e. the upper left
number on the number pad, will set it so the default upper left part
of the chart is seen. Pressing the '3' key, on the lower right corner
of the pad, will show the lower right corner of charts larger than
the screen size. Pressing '5' will show the middle area of the chart,
with equal amounts of the chart clipped from left and right, and top
and bottom. Pressing '6' will show the right end of the chart,
vertically centered on the screen, and so on. Basically, we have a
simple implementation of something like scroll bars, allowing viewing
of all parts of the "window"! One can generate and display on the
screen even the largest charts producible with Astrolog. (Bitmap
files are still limited to, i.e. will be clipped to, a maximum size
of 728x720 pixels, however). Even on an 640x350 EGA, one can use this
to generate and view all parts of a 300% scaled relationship aspect
grid (883x883), or even a 300% scaled world map display (1082x545)!

--

     Astrolog has support for the mouse and the mouse buttons when
running graphics under DOS. Upon entering a graphics chart under
DOS, a mouse pointer will appear. Holding down the left mouse button
will allow you to scribble on the screen with the mouse as a pen, in
the highlight color, just like how for Unix the left button is used
to scribble in an X window. For PC's, the middle mouse button (if you
have one - most mice such as Microsoft mice don't) will exit graphics
mode and terminate the program, like pressing the 'q' key or like how
the right mouse button does for X windows. The right mouse button
does the same thing as the middle button for X: it will reset the
current chart location to that clicked on. It won't actually display
the new longitude and latitude, but you can easily see what it is by
observing the chart information at the bottom of a graphics chart, or
by pressing the 'v' key to see the whole chart and its location in
text mode.

     The ability to use the mouse to sketch and scribble on the
charts is extended for PC's. The right mouse button (on those
non-world map charts where it doesn't already set the current
location) will draw a straight line to the mouse pointer from the
point where one last clicked the left button. Also, pressing ctrl-t
will draw a rectangle from the point of the last click to the current
mouse position.  Finally, pressing ctrl-x will draw an ellipse
inscribed within the bounds from the last click point to the current
position. These are just more features to make Astrolog a better
graphics drawing program. :) 

     Not all PC systems have mice. There is a #define in astrolog.h
called "MOUSE". If commented out, then all mouse functionality will
be compiled out, even if compiling for Unix. Note that the mouse
pointer and all PC mouse functions are temporarily disabled when
running in an animation mode. If on a PC system a mouse isn't
installed on a system and Astrolog is run with mouse features
enabled, the mouse features will be ignored as if the functionality
weren't even compiled in. 

     When implementing this, I found no readily available library
that would activate and query the mouse from DOS. The Microsoft
graphics library I used doesn't have any mouse functions in it;
however, in the C7 sample programs directory, there is an uncompiled
library file called "mouse.c" with its "mouse.h" interface. I
compiled this file as if it were one of the Astrolog program files
and linked it in to gain access to the functionality. If you are
compiling Astrolog for DOS yourself, you will probably either need to
have a copy of the Microsoft compiler or else compile out the mouse
features, unless you can find an alternate library with the same
functionality. This is further complicated by the fact that there is
a bug in the mouse.c file which causes the locations of the mouse
pointer to overflow and hence wrap before the end of the screen is
reached! I manually fixed this before compiling in mouse.c to the
official DOS executable for this version. To fix it if you want to
compile PC Astrolog yourself with this file, change line 176 in
mouse.c from: "pEvent->x = (short)((long)mi.last * mi.xActual) /
mi.xVirtual;" to: "pEvent->x = (short)((long)mi.last * mi.xActual /
mi.xVirtual);", i.e. just move the last right parenthesis to the end
of the expression. Also change line 177 in the same manner.

     [There's a minor known bug with the PC mouse features in the
program, which is that when in a flicker free graphics mode, the
mouse pointer will only appear half the time. (You can still scribble
and set location, just that the pointer won't be visible.) This is
due to the fact that a flicker free mode is actually two pages
switched back and forth between for smooth updates. If you don't see
and want your mouse here, the update generated by pressing spacebar
will revert you to the other page where the mouse pointer is.]

--

     Although Astrolog is not a Windows program and doesn't have
direct support for it with menus and all, at least not yet, Astrolog
nevertheless can be run from the Windows environment, various
features making this easier.

     One can make a Program Manager icon which will run Astrolog in a
DOS box. Using the -Q0 switch here will prompt the user for whatever
switches they want to use, as well as looping back when done to allow
additional switches to be specified much like invoking the program
over and over again from DOS. Upon exiting the program, the DOS box
will also terminate, and although not as elegant as a true Windows
interface with dialog boxes and all, this is just as if not more
usable than the DOS interface.

     To make a Windows Program Manager icon for Astrolog, first click
in the program group you want the icon to appear in, then choose File
New, and click OK to make a new program item. In the dialog, for the
description field type something like "Astrolog 4.10". For the
command line field, type "C:\ASTROLOG\ASTROLOG.EXE /Q0", i.e.
whatever the path name is to the executable file, and you probably
want to include the /Q0. For the working directory field, type
"C:\ASTROLOG", i.e. just the path to the directory where the astrolog
files are. For the shortcut key you can leave it blank or press a key
like 'a', meaning that pressing Ctrl-Alt-A at any time when the
Program Manager is active will start the Astrolog program.

     Then click on the change icon button, OK the warning, and from
the Change Icon dialog type "C:\ASTROLOG\ASTROLOG.ICO" (again the
path to your Astrolog directory) in the filename field. This should
load in Astrolog's own Windows icon file included in the zip archive,
a yellow planet with red rings and two blue moons and stars around
it. Click OK twice and you should be back in your group with a nice
Astrolog icon that can be double clicked on to boot Astrolog whenever
you want.

     You may also want to include "/V 43" or something similar along
with /Q0 for the command line field, if you want to have more than
just 25 rows in the DOS box to print the text charts in. One can also
create additional icons that have certain other switches or directly
display certain charts. For example, have another icon called
"Astrolog Now!" which has "/n /X /Q" for its switches. Double click
on this to see where the planets are right now. You can also use the
PIF editor utility (usually PIFEDIT.EXE in the Windows directory)
instead to create an astrolog.pif file. With the right system and
settings, you can specify a created .pif file instead of the Astrolog
executable directly, in the Program Manager icon, and run the program
in a window in real time along with your other Windows apps, just
like Astrolog on X windows!

--

     Finally, for PC's with graphics, the actual modes the program
enters when in the "normal" and the "flicker free animation" modes
can be customized and set in astrolog.dat. The values are the various
mode numbers defined in graph.h for the Microsoft library. By
default, the normal high-res mode is set to the value "-3", which
means a mode with the highest resolution, which is usually 640x480 16
color VGA. The default low-res animation mode is set to "16", which
corresponds to 640x350 16 color EGA (which on most systems is the
highest resolution allowing multiple pages meaning animation can be
done without flicker). Here is a complete table of the legal graphics
modes, with their index values to specify them, their screen pixel
resolution, their number of colors, and any comments as to what
hardware are required for them. It is not recommended to attempt to
enter a graphics mode here that your system doesn't support.

Num. Hor.   Ver. Col. Device.
 -3  640 x  480,  16 ("highest resolution" up to 640x480, usually #18)
 -2  320 x  200, 256 ("most colors", usually #19)
  4  320 x  200,   4 (MRES)
  5  320 x  200,   4 (4 grays)
  6  640 x  200,   2 (CGA)
  8  720 x  348,   2 (Mono Hercules)
 13  320 x  200,  16 (MRES)
 14  640 x  200,  16 (CGA)
 15  640 x  350,   2 (Mono EGA)
 16  640 x  350,  16 (EGA, maybe just 4 colors)
 17  640 x  480,   2 (Mono VGA)
 18  640 x  480,  16 (VGA)
 19  320 x  200, 256 (MRES)
 64  640 x  400,   2 (Olivetti, 1 of 16 colors)
256  640 x  400, 256 (VESA SVGA)
257  640 x  480, 256 (VESA SVGA)
258  800 x  600,  16 (NEC MultiSync 3D)
259  800 x  600, 256 (NEC MultiSync 3D)
260 1024 x  768,  16 (NEC MultiSync 4D)
261 1024 x  768, 256 (NEC MultiSync 4D)
262 1280 x 1024,  16 (NEC MultiSync 5D)
263 1280 x 1024, 256 (NEC MultiSync 5D)

--

#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
+     Walter D. "Cruiser1" Pullen    |    cruiser1@stein.u.washington.edu     +
#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
+   "Who am I, What am I?  As I am, I am not.  But as we are, I AM.  And to   +
#   you my creation, My Perfect Love is your Perfect Freedom. And I will be   #
+   with you forever and ever, until the End, and then forever more." - GOD   +
#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
